//Copyright (C) 2000 - 2003 Thomas Schank 
// 
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

#ifndef _DT_TYPE_H
#define _DT_TYPE_H

#include "constants.h"
#include "packet.h"
#include "gpdlinetool.h"

#include <string>
#include <iostream>

namespace gpspoint2 {
using namespace std;
using namespace gpspoint2;


/// a class to store and handle date and time
class Date_Time_Type : GPDLineTool, Constants
{
   public:

   virtual ~Date_Time_Type(){}

   /// output-string return the data in gpd-string format 
   string os(void);

   void os(ostream);

   Date_Time_Type(void);

   /// set the data by garmin-packet 
   virtual void set(Packet);

   /// make Packet
   virtual Packet makePacket(void);
   
   /// set the data by gpd-string
   void set(string);

   /// same as set
   void operator<<(string);

   /// 
   virtual void clear(void);

   protected:

      int second;
      int minute;
      int hour;

      int day;
      int month;
      int year;

   private:

      
};

}
#endif 
